#ifndef ENTITY_H
#define ENTITY_H

#include "glm/mat4x4.hpp"
#include <vector>

class Mesh;
class Material;
class Shader;

class Entity
{
protected:
    Mesh* mesh;
    Material* mat;
    glm::mat4 modelMatrix;
public:
    Entity(Mesh* myMesh, Material* myMat);
    virtual void draw(const glm::mat4 viewMatrix, const glm::mat4 projectionMatrix);
    glm::mat4* getTransform();
    Shader* getShader();
    Material* getMaterial();
};

#endif // ENTITY_H
