#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "sparrowrenderer.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::dockWidgetClosed()
{
    emit(ui->dockWidget->setVisible(true));
}

void MainWindow::updateTree()
{
    QTreeWidget* tree = ui->treeWidget;
    SparrowRenderer* renderer = ui->openGLWidget->getRenderer();
    tree->clear();
    for(int i=0; i<renderer->getNbModules(); ++i)
    {
        std::string moduleName = renderer->getModuleName(i);
        QTreeWidgetItem* item = new QTreeWidgetItem();
        item->setText(0, QString(moduleName.c_str()));
        tree->addTopLevelItem(item);
    }
}

void MainWindow::moduleSetEnabled(QTreeWidgetItem* item, int button)
{
    SparrowRenderer* renderer = ui->openGLWidget->getRenderer();
    std::string name = item->text(0).toStdString();
    if(renderer->isModuleEnabled(name))
        renderer->disableModule(name);
    else
        renderer->enableModule(name);
    ui->openGLWidget->updateGL();
}
