#ifndef SKYBOXMODULE_H
#define SKYBOXMODULE_H

#include <glew/glew.h>
#include "module.h"
#include <string>

class Shader;
class Texture;

class SkyboxModule : public Module
{
    static const GLfloat skyboxVertices[];
    static const std::string vertSource;
    static const std::string fragSource;

    GLuint vao;
    GLuint vbo;
    GLuint mvpLocation;
    Shader* shader;
    Texture* cubeMap;
public:
    SkyboxModule(Texture* myCubeMap);
    ~SkyboxModule();
    virtual void render(Camera* myCamera);
};

#endif // SKYBOXMODULE_H
